
' How To Write A Chess Program in QBASIC
' By Dean Menezes

declare function SHOWMAN(A as const integer, B as const integer) as string
declare sub SHOWBD()
declare sub IO(A as const integer, B as const integer, X as const integer, Y as const integer, RESULT as const integer)
declare function INCHECK(TODO as const integer) as integer
declare sub MAKEMOVE(A as const integer, B as const integer, X as const integer, Y as const integer)
declare sub KNIGHT(A as const integer, B as const integer, XX() as integer, YY() as integer, byref NDX as integer)
declare sub KING(A as const integer, B as const integer, XX() as integer, YY() as integer, byref NDX as integer)
declare sub QUEEN(A as const integer, B as const integer, XX() as integer, YY() as integer, byref NDX as integer)
declare sub ROOK(A as const integer, B as const integer, XX() as integer, YY() as integer, byref NDX as integer)
declare sub BISHOP(A as const integer, B as const integer, XX() as integer, YY() as integer, byref NDX as integer)
declare sub MOVELIST(A as const integer, B as const integer, XX() as integer, YY() as integer, byref NDX as integer)
declare sub PAWN(A as const integer, B as const integer, XX() as integer, YY() as integer, byref NDX as integer)
declare function EVALUATE(ID as const integer, PRUNE as const integer) as integer
dim shared as integer BOARD(0 to 7, 0 to 7)
dim shared as integer BESTA(0 to 7), BESTB(0 to 7), BESTX(0 to 7), BESTY(0 to 7)
dim shared as integer LEVEL, MAXLEVEL, SCORE, CFLAG
CFLAG = 0
LEVEL = 0
MAXLEVEL = 5

data  -500, -270, -300, -900,-7500, -300, -270, -500
data  -100, -100, -100, -100, -100, -100, -100, -100
data     0,    0,    0,    0,    0,    0,    0,    0
data     0,    0,    0,    0,    0,    0,    0,    0
data     0,    0,    0,    0,    0,    0,    0,    0
data     0,    0,    0,    0,    0,    0,    0,    0
data   100,  100,  100,  100,  100,  100,  100,  100
data   500,  270,  300,  900, 5000,  300,  270,  500

dim Z as integer
for Y as integer = 0 to 7
  for X as integer = 0 to 7
    read Z
    BOARD(Y, X) = Z
  next X
next Y

dim as integer A = -1, B = -1, X = -1, Y = -1
dim as integer RESULT = 0
do
  SCORE = 0
  IO(A, B, X, Y, RESULT)
  RESULT = EVALUATE(-1, 10000)
  A = BESTA(1)
  B = BESTB(1)
  X = BESTX(1)
  Y = BESTY(1)
loop

#macro GOSUB_3
if ID <> sgn(BOARD(Y, X)) then
  NDX = NDX + 1
  XX(NDX) = X
  YY(NDX) = Y
end if
#endmacro

sub BISHOP(A as const integer, B as const integer, XX() as integer, YY() as integer, byref NDX as integer)
  dim as integer ID = sgn(BOARD(B, A)), X, Y
  
  for DXY as integer = 1 to 7
    X = A - DXY
    Y = B + DXY
    if X < 0 or X > 7 or Y < 0 or Y > 7 then exit for
    GOSUB_3
    if BOARD(Y, X) then exit for
  next
  
  for DXY as integer = 1 to 7
    X = A + DXY
    Y = B + DXY
    if X < 0 or X > 7 or Y < 0 or Y > 7 then exit for
    GOSUB_3
    if BOARD(Y, X) then exit for
  next
  
  for DXY as integer = 1 to 7
    X = A - DXY
    Y = B - DXY
    if X < 0 or X > 7 or Y < 0 or Y > 7 then exit for
    GOSUB_3
    if BOARD(Y, X) then exit for
  next
  
  for DXY as integer = 1 to 7
    X = A + DXY
    Y = B - DXY
    if X < 0 or X > 7 or Y < 0 or Y > 7 then exit for
    GOSUB_3
    if BOARD(Y, X) then exit for
  next
end sub

function EVALUATE(ID as const integer, PRUNE as const integer) as integer
  dim as integer XX(0 to 26), YY(0 to 26)
  LEVEL = LEVEL + 1
  dim as integer BESTSCORE = 10000 * ID
  dim as integer NDX = -1, X, Y, OLDSCORE, MOVER, TARGET
  for B as integer = 7 to 0 step -1
    for A as integer = 7 to 0 step -1
      if sgn(BOARD(B, A)) <> ID then continue for'GOTO 1
      MOVELIST(A, B, XX(), YY(), NDX)
      for I as integer = 0 to NDX
        X = XX(I)
        Y = YY(I)
        OLDSCORE = SCORE
        MOVER = BOARD(B, A)
        TARGET = BOARD(Y, X)
        MAKEMOVE(A, B, X, Y)
        if (LEVEL < MAXLEVEL) then SCORE = SCORE + EVALUATE(-ID, BESTSCORE - TARGET + ID * (8 - abs(4 - X) - abs(4 - Y)))
        SCORE = SCORE + TARGET - ID * (8 - abs(4 - X) - abs(4 - Y))
        if (ID < 0 and SCORE > BESTSCORE) or (ID > 0 and SCORE < BESTSCORE) then
          BESTA(LEVEL) = A
          BESTB(LEVEL) = B
          BESTX(LEVEL) = X
          BESTY(LEVEL) = Y
          BESTSCORE = SCORE
          if (ID < 0 and BESTSCORE >= PRUNE) or (ID > 0 and BESTSCORE <= PRUNE) then
            BOARD(B, A) = MOVER
            BOARD(Y, X) = TARGET
            SCORE = OLDSCORE
            LEVEL = LEVEL - 1
            EVALUATE = BESTSCORE
            exit function
          end if
        end if
        BOARD(B, A) = MOVER
        BOARD(Y, X) = TARGET
        SCORE = OLDSCORE
      next
    next
  next
  LEVEL = LEVEL - 1
  EVALUATE = BESTSCORE
end function

function INCHECK(TODO as const integer) as integer
  dim as integer XX(27), YY(27), NDX, X, Y
  for B as integer = 0 to 7
    for A as integer = 0 to 7
      if BOARD(B, A) >= 0 then continue for'GOTO 6
      MOVELIST(A, B, XX(), YY(), NDX)
      for I as integer = 0 to NDX step 1
        X = XX(I)
        Y = YY(I)
        if BOARD(Y, X) = 5000 then
          'PRINT "YOU ARE IN CHECK!"
          INCHECK = 1
          exit function
        end if
      next
    '6 NEXT
    next
  next
  INCHECK = 0
end function

sub IO(A as const integer, B as const integer, X as const integer, Y as const integer, RESULT as const integer)
  dim as integer XX(0 to 26), YY(0 to 26), PIECE = 0, NDX = -1, MOVER, TARGET
  dim cmd as string
  dim as integer A_, B_, X_, Y_
  if A >= 0 then
    if RESULT < -2500 then
      'PRINT "I RESIGN"
      system
    end if
    PIECE = BOARD(Y, X)
    MAKEMOVE(A, B, X, Y)
    print "MYMOVE "; chr(65 + A, 8 - B + asc("0"), 65 + X, 8 - Y + asc("0"))
    'NULL = INCHECK(0)
    if INCHECK(0) then print "CHECK!"
  end if
  
  do
    SHOWBD
    input "", cmd
    if UCASE$(cmd) = "QUIT" then end
    if UCASE$(cmd) = "O-O" then
      if CFLAG then continue do'GOTO 16
      if BOARD(7, 7) <> 500 then continue do'GOTO 16
      if BOARD(7, 6) or BOARD(7, 5) then continue do'GOTO 16
      BOARD(7, 6) = 5000
      BOARD(7, 4) = 0
      BOARD(7, 5) = 500
      BOARD(7, 7) = 0
      CFLAG = 1
      exit sub
    end if
    if UCASE$(cmd) = "O-O-O" then
      if CFLAG then continue do'GOTO 16
      if BOARD(7, 0) <> 500 then continue do'GOTO 16
      if BOARD(7, 1) or BOARD(7, 2) or BOARD(7, 3) then continue do'GOTO 16
      BOARD(7, 2) = 5000
      BOARD(7, 4) = 0
      BOARD(7, 3) = 500
      BOARD(7, 0) = 0
      CFLAG = 1
      exit sub
    end if
    
    if len(cmd) < 4 then continue do'GOTO 16
    
    A_ = asc(UCASE$(MID$(cmd, 1, 1))) - 65
    B_ = 8 - (asc(MID$(cmd, 2, 1)) - 48)
    X_ = asc(UCASE$(MID$(cmd, 3, 1))) - 65
    Y_ = 8 - (asc(MID$(cmd, 4, 1)) - 48)
    
    if B_ > 7 or B_ < 0 or A_ > 7 or A_ < 0 or X_ > 7 or X_ < 0 or Y_ > 7 or Y_ < 0 then continue do'GOTO 16
    if BOARD(B_, A_) <= 0 then continue do'GOTO 16
    
    MOVELIST(A_, B_, XX(), YY(), NDX)
    
    for K as integer = 0 to NDX step 1
      if X_ = XX(K) and Y_ = YY(K) then
        MOVER = BOARD(B_, A_)
        TARGET = BOARD(Y_, X_)
        MAKEMOVE(A_, B_, X_, Y_)
        if INCHECK(0) = 0 then exit sub
        BOARD(B_, A_) = MOVER
        BOARD(Y_, X_) = TARGET
        continue do'GOTO 16
      end if
    next
    '16
  loop
end sub

sub KING(A as const integer, B as const integer, XX() as integer, YY() as integer, byref NDX as integer)
  dim as integer ID = sgn(BOARD(B, A))
  for DY as integer = -1 to 1
    if B + DY < 0 or B + DY > 7 then continue for'GOTO 12
    for DX as integer = -1 to 1
      if A + DX < 0 or A + DX > 7 then continue for'GOTO 11
      if ID <> sgn(BOARD(B + DY, A + DX)) then
        NDX = NDX + 1
        XX(NDX) = A + DX
        YY(NDX) = B + DY
      end if
    '11 NEXT
    next
  '12 NEXT
  next
end sub

#macro GOSUB_5
if (X >= 0) and (X <= 7) and (Y >= 0) and (Y <= 7) andalso (ID <> sgn(BOARD(Y, X))) then
  NDX = NDX + 1
  XX(NDX) = X
  YY(NDX) = Y
end if
#endmacro

sub KNIGHT(A as const integer, B as const integer, XX() as integer, YY() as integer, byref NDX as integer)
  dim as integer ID = sgn(BOARD(B, A)), X, Y
  X = A - 1
  Y = B - 2
  GOSUB_5
  X = A - 2
  Y = B - 1
  GOSUB_5
  X = A + 1
  Y = B - 2
  GOSUB_5
  X = A + 2
  Y = B - 1
  GOSUB_5
  X = A - 1
  Y = B + 2
  GOSUB_5
  X = A - 2
  Y = B + 1
  GOSUB_5
  X = A + 1
  Y = B + 2
  GOSUB_5
  X = A + 2
  Y = B + 1
  GOSUB_5
end sub

sub MAKEMOVE(A as const integer, B as const integer, X as const integer, Y as const integer)
  BOARD(Y, X) = BOARD(B, A)
  BOARD(B, A) = 0
  if Y = 0 and BOARD(Y, X) = 100 then BOARD(Y, X) = 900
  if Y = 7 and BOARD(Y, X) = -100 then BOARD(Y, X) = -900
end sub

sub MOVELIST(A as const integer, B as const integer, XX() as integer, YY() as integer, byref NDX as integer)
  dim as integer PIECE = int(abs(BOARD(B, A)))
  NDX = -1
  if PIECE = 100 then
    PAWN(A, B, XX(), YY(), NDX)
  elseif PIECE = 270 then KNIGHT(A, B, XX(), YY(), NDX)
  elseif PIECE = 300 then BISHOP(A, B, XX(), YY(), NDX)
  elseif PIECE = 500 then ROOK(A, B, XX(), YY(), NDX)
  elseif PIECE = 900 then QUEEN(A, B, XX(), YY(), NDX)
  else KING(A, B, XX(), YY(), NDX)
  end if
end sub

sub PAWN(A as const integer, B as const integer, XX() as integer, YY() as integer, byref NDX as integer)
  dim as integer ID = sgn(BOARD(B, A))
  if (A - 1) >= 0 and (A - 1) <= 7 and (B - ID) >= 0 and (B - ID) <= 7 then
    if sgn(BOARD((B - ID), (A - 1))) = -ID then
      NDX = NDX + 1
      XX(NDX) = A - 1
      YY(NDX) = B - ID
    end if
  end if
  if (A + 1) >= 0 and (A + 1) <= 7 and (B - ID) >= 0 and (B - ID) <= 7 then
    if sgn(BOARD((B - ID), (A + 1))) = -ID then
      NDX = NDX + 1
      XX(NDX) = A + 1
      YY(NDX) = B - ID
    end if
  end if
  if A >= 0 and A <= 7 and (B - ID) >= 0 and (B - ID) <= 7 then
    if BOARD((B - ID), A) = 0 then
      NDX = NDX + 1
      XX(NDX) = A
      YY(NDX) = B - ID
      if (ID < 0 and B = 1) or (ID > 0 and B = 6) then
        if BOARD((B - ID - ID), A) = 0 then
          NDX = NDX + 1
          XX(NDX) = A
          YY(NDX) = B - 2 * ID
        end if
      end if
    end if
  end if
end sub

sub QUEEN(A as const integer, B as const integer, XX() as integer, YY() as integer, byref NDX as integer)
  BISHOP(A, B, XX(), YY(), NDX)
  ROOK(A, B, XX(), YY(), NDX)
end sub

sub ROOK(A as const integer, B as const integer, XX() as integer, YY() as integer, byref NDX as integer)
  dim as integer ID = sgn(BOARD(B, A))
  
  for X as integer = A - 1 to 0 step -1
    if ID <> sgn(BOARD(B, X)) then
    NDX = NDX + 1
    XX(NDX) = X
    YY(NDX) = B
    end if
    if (BOARD(B, X)) then exit for
  next
  
  for X as integer = A + 1 to 7 step 1
    if ID <> sgn(BOARD(B, X)) then
    NDX = NDX + 1
    XX(NDX) = X
    YY(NDX) = B
    end if
    if (BOARD(B, X)) then exit for
  next
  
  for Y as integer = B - 1 to 0 step -1
    if ID <> sgn(BOARD(Y, A)) then
    NDX = NDX + 1
    XX(NDX) = A
    YY(NDX) = Y
    end if
    if (BOARD(Y, A)) then exit for
  next
  
  for Y as integer = B + 1 to 7 step 1
    if ID <> sgn(BOARD(Y, A)) then
    NDX = NDX + 1
    XX(NDX) = A
    YY(NDX) = Y
    end if
    if (BOARD(Y, A)) then exit for
  next
end sub

sub SHOWBD
  print "+   A B C D E F G H   +"
  print
  for B as integer = 0 to 7
    print chr(56 - B) & "   ";
    for A as integer = 0 to 7
      print SHOWMAN(A, B) & " ";
    next
    print "  " & chr(56 - B)
  next
  print
  print "+   A B C D E F G H   +"
end sub

function SHOWMAN(A as const integer, B as const integer) as string
  dim symb as string = "."
  dim as integer PIECE = int(abs(BOARD(B, A)))
  if PIECE = 100 then symb = "P"
  if PIECE = 270 then symb = "N"
  if PIECE = 300 then symb = "B"
  if PIECE = 500 then symb = "R"
  if PIECE = 900 then symb = "Q"
  if PIECE = 5000 or PIECE = 7500 then symb = "K"
  if board(b, a) < 0 then symb = lcase(symb)
  return symb
end function
