
#include once "log.bi"
#include once "uci.bi"
#include once "jschess\player.bi"
#include once "chess\chess.bi"
#include once "validator.bi"
#include once "version.bi"

const STARTPOS = "rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1"
const ERRORFLAG = "a1a1"

OpenLog("mosquito.log")
ToLog(Time())

dim as string cmd = "", ss(), fen = STARTPOS, move
dim exitLoop as boolean = false
dim game as chess.tChessGame

while not exitLoop
  Sleep 10
  input "", cmd
  ToLog(cmd)
  
  if uci.IsCommandQuit(cmd) then
    exitLoop = true
  
  elseif uci.IsCommandUCI(cmd) then
    Print("id name " & PROGRAM_NAME & " " & PROGRAM_VERSION)
    Print("id author " & AUTHOR_NAME)
    Print("uciok")
  
  elseif uci.IsCommandReady(cmd) then
    Print("readyok")
  
  elseif uci.IsCommandNewGame(cmd)  then
    fen = STARTPOS
  
  elseif uci.IsCommandPosition(cmd) then
    if uci.IsCommandStartPos(cmd) then
      fen = STARTPOS
      game.Initialize(fen)
      
      if uci.IsCommandMoves(cmd) andalso uci.GetMoves(cmd, ss()) then
        for i as integer = lbound(ss) to ubound(ss)
          game.DoMove(ss(i))
        next i
        fen = game.FEN()
      end if
    elseif uci.IsCommandFEN(cmd) then
      uci.GetFEN(cmd, fen)
    end if
  
  elseif uci.IsCommandGo(cmd) then
    if IsFEN(fen) then
      move = BestMove(fen)
      game.Initialize(fen)
      if game.IsPromotion(move) then
        move += "q"
      end if
    else
      move = ERRORFLAG
      ToLog("Invalid FEN string: """ & fen & """")
    end if
    Print("bestmove " & move)
  end if
wend

CloseLog()
