namespace sGUI

declare function AddLabel (event as EventHandle ptr,PosX as integer,PosY as integer,Text as string,TextColor as integer=TextColor) as Gadget ptr
declare function LabelActions(gad as Gadget ptr,action as integer) as integer
declare sub DrawLabel (gad as Gadget ptr)
declare sub UpdateLabel (gad as Gadget ptr)

declare sub SetLabelColor (gad as Gadget ptr,TextColor as integer)

'Ctrl(0) Farbe des Textes
'Images(2) Hintergrund von PosX-Position bis rechter Screenrand
function AddLabel (event as EventHandle ptr,PosX as integer,PosY as integer,Text as string,TextColor as integer=TextColor) as Gadget ptr
  function=0
  dim as Gadget ptr gad
  gad=event->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->event=event

  	gad->sel=0
    gad->act=0
    gad->posx=PosX
    gad->posy=PosY
    gad->gadw=8*len(Text)
    gad->gadh=fontheight

    gad->caption=Text

    gad->Ctrl(0)=TextColor

    gad->DoDraw     =@DrawLabel
    gad->DoAction   =@LabelActions
    gad->DoUpdate   =@UpdateLabel

		gad->SaveBackGround
		function=gad
  end if
end function



function LabelActions(gad as Gadget ptr,action as integer) as integer
  function=0
  select case action

      case GADGET_HIT        'Control grad frisch gedrckt

      case GADGET_HOLD       'Control wird gehalten, Maus ber dem Control

      case GADGET_HOLDOFF    'Control wird gehalten, Maus neben dem Control

      case GADGET_RELEASE    'Control regulr losgelassen, Maus ber dem Control
        function=1
      
      case GADGET_RELEASEOFF 'Control losgelassen, dabei ist Maus neben dem Control

  end select
end function



sub DrawLabel (gad as Gadget ptr)
	dim as integer PosX,PosY,GadWidth,GadgHeight
  dim as string Text
  PosX   =gad->posx
	PosY   =gad->posy
	GadWidth		=gad->gadw
	GadgHeight		=gad->gadh
  if listener <> 0 then mutexlock(listener->sync)
  screenlock
	if gad->act=0 then
    put(PosX,PosY),gad->Background,pset
  else
    draw string ( PosX, PosY),gad->caption,gad->Ctrl(0)
    if gad->act=2 then put(PosX,PosY),gad->Background,alpha,SleepShade
  end if
  screenunlock
  if listener <> 0 then mutexunlock(listener->sync)
end sub



sub UpdateLabel (gad as Gadget ptr)
  put(gad->posx,gad->posy),gad->Background,pset  'Restaurieren des originalen Screenhintergrundes
  gad->gadw=len(gad->caption)*8                       'neue Breite nach Lnge des neuen String setzen
  gad->SaveBackground                                 'Hintergrund sichern
  DrawGadget(gad)                                     'Neuzeichnen
end sub



sub SetLabelColor (gad as Gadget ptr,TextColor as integer)
  gad->Ctrl(0)=TextColor
  gad->DoDraw(gad)
end sub

end namespace
