namespace sGUI

declare function AddLBGadget (event as EventHandle ptr,PosX as integer,PosY as integer,NumChars as integer,NumRows as integer, DisplayMode as integer=0) as Gadget ptr
declare function LBActions(gad as Gadget ptr,action as integer) as integer
declare sub DrawLB(gad as Gadget ptr)

declare sub VScrollLB(gad as Gadget ptr,l as integer)

'Ctrl(0)=Breite der Box in Zeichen
'Ctrl(1)=Hhe der Box in Zeilen
'Ctrl(2)=angescrollte Zeile, fr Vertikalscrolling, oberste sichtbare Zeile in der Box
'Ctrl(3) DisplayMode 0="Normale Darstellung", 1=String ist nach Label und Item zu unterscheiden
'Ctrl(14) Regel/Returngre: im DisplayMode 1 Item ID
'Ctrl(15)= Regel/Returngre: im DisplayMode 0 angeklickte Zeile
function AddLBGadget (event as EventHandle ptr,PosX as integer,PosY as integer,NumChars as integer,NumRows as integer,DisplayMode as integer=0) as Gadget ptr
  function=0
  dim as Gadget ptr gad
  gad=event->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->event=event
  	gad->sel=0
    gad->act=0
    gad->posx=PosX
    gad->posy=PosY
    gad->gadw=NumChars*8 + 6
    gad->gadh=fontheight*NumRows + 6
    
    gad->Ctrl(3)=DisplayMode
    gad->Ctrl(15)=0

    gad->Ctrl(0)=NumChars
    gad->Ctrl(1)=NumRows
    gad->Ctrl(2)=1

    gad->DoDraw     =@DrawLB
    gad->DoAction   =@LBActions
    gad->DoUpdate   =@DrawLB
    
    gad->TObject=new TextObject

		gad->SaveBackGround
		function=gad
  end if
end function



function LBActions(gad as Gadget ptr,action as integer) as integer
  function=0
  dim as integer l,ll,lcl,offset
  dim as string lc,header,itemid

  select case action

      case GADGET_HIT        'Control grad frisch gedrckt
        ll=TO_GetLines(gad)
        l=0
        offset=3
        if ll then'wenn Zeilen im TO
          if MOUSEY>=gad->posy+offset and MOUSEY<gad->posy + gad->gadh-offset then
            l=gad->Ctrl(2) + int((MOUSEY-gad->posy-offset)/fontheight)
            if l>ll then l=ll
          end if
        end if
        if l>0 then'sollte gltig eine Zeile angeklickt worden sein
          if gad->Ctrl(3) then 'DisplayMode 1
            lc=TO_GetLineContent(gad,l)
            header=left(lc,3)
            if header="ITM" then
              itemid=mid(lc,5,3)
              gad->Ctrl(14)=val(itemid)
              gad->Ctrl(15)=l
              DrawGadget(gad)              
              function=1
            else
              'nichts
            end if
          else                    'DisplayMode 0
            gad->Ctrl(15)=l
            DrawGadget(gad)        
            function=1
          end if
        end if

      case GADGET_HOLD       'Control wird gehalten, Maus ber dem Control

      case GADGET_HOLDOFF    'Control wird gehalten, Maus neben dem Control

      case GADGET_RELEASE    'Control regulr losgelassen

      case GADGET_RELEASEOFF 'Control losgelassen, dabei ist Maus neben dem Control

      case GADGET_KEYBOARD   'Keyboardauswertung

  end select
end function



sub DrawLB (gad as Gadget ptr)
	dim as integer PosX,PosY,GadWidth,GadHeight,offset,NumRows
  dim as integer boxc,boxl,scrollpos,scrollline,lcount,selline
	dim as uinteger tcolor
  dim as TextLine ptr l
  dim as string tmpstring,cursorchar
  PosX   =gad->posx
	PosY   =gad->posy
	GadWidth		   =gad->gadw
	GadHeight		   =gad->gadh
	offset=3
  NumRows=TO_GetLines(gad)
  boxc=gad->Ctrl(0)
  boxl=gad->Ctrl(1)
  scrollpos=gad->Ctrl(2)
  scrollline=gad->Ctrl(2)
  l=TO_GetLineAddr(gad,scrollline)
  selline=gad->Ctrl(15)

  tmpstring=""
  if listener <> 0 then mutexlock(listener->sync)
  screenlock
  if gad->act=0 then
'OFF
    put(PosX,PosY),gad->Background,pset
  else
'ON
    FrameB PosX,PosY,GadWidth,GadHeight,1
		ClearBox PosX+1,PosY+1,GadWidth-2,GadHeight-2,white
    if NumRows then
      lcount=0
      do
        tmpstring=TO_GetLineContent(gad,l)

        if gad->Ctrl(3) then  'DisplayMode 1
          
          if left(tmpstring,3)="LBL" then
            tmpstring=left(right(tmpstring,len(tmpstring)-4),boxc)
            FillA PosX+1,PosY+offset+lcount*fontheight,GadWidth-2,fontheight,BackgroundColor,0
            tcolor=&HEE5500
          end if

          if left(tmpstring,3)="ITM" then 
            tmpstring=left(space(2) & right(tmpstring,len(tmpstring)-8),boxc)
            if (scrollline+lcount=selline) then
              tcolor=white
              ClearBox PosX+1,PosY+offset+lcount*fontheight,GadWidth-2,fontheight,CursorColor
            else
              tcolor=TextColor
            end if                     
          end if
          
        else                  'DisplayMode 0
         
          tmpstring=left(tmpstring,boxc)
          if (scrollline+lcount=selline) then
            tcolor=white
            ClearBox PosX+1,PosY+offset+lcount*fontheight,GadWidth-2,fontheight,CursorColor
          else
            tcolor=TextColor
          end if        
        
        end if

        draw string ( PosX+offset, PosY+offset+lcount*fontheight ),tmpstring,tcolor

        l=l->nextline
  		  lcount +=1
      loop until (l=0) or (lcount=boxl)'keine Zeile im TO oder der Zeilenzhler=Anzahl der zu zeigenden Zeilen(lcount startet bei 0!)
    end if
'SLEEP
    if gad->act=2 then put(PosX,PosY),gad->Background,alpha,SleepShade
  end if
  screenunlock
  if listener <> 0 then mutexunlock(listener->sync)
end sub



sub VScrollLB(gad as Gadget ptr,l as integer)
  gad->Ctrl(2)=l
end sub

end namespace
