#include once "MultiLineEditBox_Basis.bas"
#include once "ScrollBar.bas"

namespace sGUI

declare function AddMultiLineEditBox (event as EventHandle ptr,PosX as integer,PosY as integer,NumChars as integer,NumRows as integer,DisplayMode as integer=1) as Gadget ptr
declare function MultiLineEditActions(gad as Gadget ptr,action as integer) as integer
declare sub DrawMultiLineEdit (gad as Gadget ptr)

declare sub MultiLineEditSubHandle(gad as Gadget ptr)
declare sub UpdateMLEB(gad as Gadget ptr)

'Ctrl(4)  0=Viewmodus 1=Editormodus
function AddMultiLineEditBox(event as EventHandle ptr,PosX as integer,PosY as integer,NumChars as integer,NumRows as integer,DisplayMode as integer=1) as Gadget ptr
  function=0
  dim as Gadget ptr gad
  gad=event->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->event=event
  	gad->sel=0
    gad->act=0
    gad->posx=PosX
    gad->posy=PosY
    gad->gadw=NumChars*8 + 6 + 15 '6 >> Rand innerhalb MLEB,  15>> Breite ScrollBar rechts
    gad->gadh=fontheight*NumRows + 6 + 15'6 >> Rand innerhalb MLEB, 15>> Hhe der ScrollBar unten
    
    gad->Ctrl(4)=DisplayMode
    
    gad->subevent=new EventHandle
		if gad->subevent then
      gad->gad(0)=AddMLEBGadget(gad->subevent,PosX,PosY,NumChars,NumRows,DisplayMode)
    	gad->gad(1)=AddScrollBar(gad->subevent,PosX+NumChars*8 + 6,PosY,NumRows*fontheight+6,1,1,1,NumRows,1)
    	gad->gad(2)=AddScrollBar(gad->subevent,PosX,PosY+NumRows*fontheight+6,NumChars*8+6,1,1,1,NumChars,0)
		end if

    gad->TObject=gad->gad(0)->TObject'Verbindung zum Textobjekt erzeugen das eigentlich zur LB in gad(0) gehrt

    gad->DoDraw     =@DrawMultiLineEdit
    gad->DoAction   =@MultiLineEditActions
    gad->DoUpdate   =@UpdateMLEB

		'gad->SaveBackGround
		function=gad
  end if
end function



function MultiLineEditActions(gad as Gadget ptr,action as integer) as integer
  function=0
  dim as integer enable
  select case action

      case GADGET_HIT
        MultiLineEditSubHandle(gad)
        SetSelect(gad->gad(0),1)
        function=-1

      case GADGET_HOLD,GADGET_HOLDOFF,GADGET_RELEASE,GADGET_RELEASEOFF
        MultiLineEditSubHandle(gad)

      case GADGET_KEYBOARD   'Keyboardauswertung
        'ob eine Taste gedrckt wurde ist schon in GadgetControl berprft worden
        'wenn man bis hierher gelangt ist, wurde definitiv etwas gedrckt
        if  EXTENDED then
          'Cursorbewegung mit Pfeiltasten
          if ASCCODE=75 then TO_CursorLeft(gad)
          if ASCCODE=77 then TO_CursorRight(gad)
          if ASCCODE=72 then TO_CursorUp(gad)
          if ASCCODE=80 then TO_CursorDown(gad)
          'added by MilkFreeze, modified by Muttonhead :D
          if ASCCODE=71 then TO_CursorKeyPos1(gad)
          if ASCCODE=79 then TO_CursorKeyEnd(gad)
          ModifyScrollBar(gad->gad(2),TraceCursorPosition(gad->gad(0)))
          ModifyScrollBar(gad->gad(1),TraceCursorLine(gad->gad(0)))
          DrawGadget(gad->gad(0))
          'DEL Windows
          #ifdef __fb_win32__
            if ASCCODE=83 then
              TO_KeyDelete(gad)
              ModifyScrollBar(gad->gad(1),1,TO_GetLines(gad),TraceCursorLine(gad->gad(0)))
              ModifyScrollBar(gad->gad(2),TraceCursorPosition(gad->gad(0)))
              DrawGadget(gad->gad(0))
            end if
          #endif

        else

          'BACKSPACE
          if ASCCODE=8 then
            TO_KeyBackspace(gad)
            ModifyScrollBar(gad->gad(1),1,TO_GetLines(gad),TraceCursorLine(gad->gad(0)))
            ModifyScrollBar(gad->gad(2),TraceCursorPosition(gad->gad(0)))
            DrawGadget(gad->gad(0))
          end if

          'DEL Linux
          #ifdef __fb_linux__
            if ASCCODE=127 then
              TO_KeyDelete(gad)
              ModifyScrollBar(gad->gad(1),1,TO_GetLines(gad),TraceCursorLine(gad->gad(0)))
              ModifyScrollBar(gad->gad(2),TraceCursorPosition(gad->gad(0)))
              DrawGadget(gad->gad(0))
            end if
          #endif

          'Return
          if ASCCODE=13 then
            TO_KeyReturn(gad)
            ModifyScrollBar(gad->gad(1),1,TO_GetLines(gad),TraceCursorLine(gad->gad(0)))
            ModifyScrollBar(gad->gad(2),TraceCursorPosition(gad->gad(0)))
            DrawGadget(gad->gad(0))
          end if

          'Zeicheneingabe
          enable=0

          'Linux chr(127) (Delete) ausschlieen
          #ifdef __fb_linux__
            if ASCCODE>=32 and ASCCODE<>127 then enable=1
          #endif

          'Windows
          #ifdef __fb_win32__
            if ASCCODE>=32 then enable=1
          #endif

          if gad->Ctrl(4)<>1 then enable=0

          if enable then
            TO_KeyAddChar(gad,KEY)
            ModifyScrollBar(gad->gad(1),1,TO_GetLines(gad),TraceCursorLine(gad->gad(0)))
            ModifyScrollBar(gad->gad(2),1,TO_GetLongestLine(gad)+1,TraceCursorPosition(gad->gad(0)))
            DrawGadget(gad->gad(0))
          end if
        end if

      case GADGET_KEYBOARDOFF'Abbruch Keyboardauswertung
        SetSelect(gad->gad(0),0)
        function=-1
      
      case GADGET_WHEELMOVE
        ModifyScrollBar(gad->gad(1),GetScrollBarVal( gad->gad(1) ) + WHEEL*3 )'3ZeilenScroll Rad
        VScrollMLEB(gad->gad(0),GetScrollBarVal(gad->gad(1)))
        DrawGadget(gad->gad(0)) 
  end select
end function



sub DrawMultiLineEdit (gad as Gadget ptr)
  DrawGadget(gad->gad(0))
  DrawGadget(gad->gad(1))  
  DrawGadget(gad->gad(2))  
end sub



sub MultiLineEditSubHandle(gad as Gadget ptr)
  'gad->subevent->xSleep(-1,0)' ein Event der als "Durchlufer" und ohne SLEEP funktioniert!!!!!!!!!!!!!!!!
  gad->subevent->GadgetControl
  if gad->subevent->GADGETMESSAGE then
    select case gad->subevent->GADGETMESSAGE
      case gad->gad(0)
        ModifyScrollBar(gad->gad(1),1,TO_GetLines(gad),TraceCursorLine(gad->gad(0)))
        ModifyScrollBar(gad->gad(2),TraceCursorPosition(gad->gad(0)))
      case gad->gad(1)
        VScrollMLEB(gad->gad(0),GetScrollBarVal(gad->gad(1)))
      case gad->gad(2)
        HScrollMLEB(gad->gad(0),GetScrollBarVal(gad->gad(2)))
    end select
    DrawGadget(gad->gad(0))
  end if
end sub



sub UpdateMLEB(gad as Gadget ptr)
  dim as integer cp,cl
  cp=TO_GetCursorPosition(gad)
  cl=TO_GetCursorLine(gad)
  ModifyScrollBar(gad->gad(1),1,TO_GetLines(gad),cl)
  ModifyScrollBar(gad->gad(2),1,TO_GetLongestLine(gad)+1,cp)
  VScrollMLEB(gad->gad(0),GetScrollBarVal(gad->gad(1)))
  HScrollMLEB(gad->gad(0),GetScrollBarVal(gad->gad(2)))
  'ModifyScrollBar(gad->gad(1),1,TO_GetLines)
  'ModifyScrollBar(gad->gad(2),1,TO_GetLongestLine+1)
  'VScrollMLEB(gad->gad(0),GetScrollBarVal(gad->gad(1)))
  'HScrollMLEB(gad->gad(0),GetScrollBarVal(gad->gad(2)))
  DrawGadget(gad->gad(0))
end sub

end namespace
