'System Includes
#include "file.bi"
#include "fbgfx.bi"

using FB

namespace sGUI

'Fwd Ref
type _Gadget        as Gadget
type _EventHandle   as EventHandle
type _MenuHeader    as MenuHeader
type _MenuItem      as MenuItem
type _TextObject    as TextObject
type _FBImage       as FBImage
type _node          as node

'allen Types denen das node type vererbt und damit "listenfhig" gemacht wurden bekommen jetzt Typkonstanten zugeordnet
'ber diese wird das entsprechende Type erzeugt, und kann auch wieder richtig entfernt werden.
const as integer NodeType=0
const as integer ListObjectType=1
const as integer EventHandleType=2
const as integer GadgetType=3

'Konstanten fr die Beschreibung des Maustastenstatus
const as integer HIT=2     'Taste grad frisch gedrckt
const as integer HOLD=3     'Taste gehalten
const as integer RELEASE=1  'Taste grad losgelassen
const as integer RELEASED=0 'Taste ist losgelassen

'Konstanten fr die Beschreibung der Ereignisse von Controls
'LMB
const as integer GADGET_HIT=1         'Control grad frisch gedrckt
const as integer GADGET_HOLD=2        'Control wird gehalten, Maus ber dem Control
const as integer GADGET_HOLDOFF=3     'Control wird gehalten, Maus neben dem Control
const as integer GADGET_RELEASE=4     'Control regulr losgelassen
const as integer GADGET_RELEASEOFF=5  'Control losgelassen, dabei ist Maus neben dem Control
const as integer GADGET_MOUSEOVER=6   'Control ist losgelassen, dabei ist Maus berm dem Control
const as integer GADGET_MOUSENEXT=7   'Control ist losgelassen, dabei ist Maus jetzt neben dem Control
'Keyboard
const as integer GADGET_KEYBOARD=8    'Control verarbeitet die Tastatureingaben
const as integer GADGET_KEYBOARDOFF=9 'Abbruch der Verarbeitung der Tastatureingaben eines Controls
'Wheel
const as integer GADGET_WHEELMOVE=10  'Rad wurde bewegt

'Konstanten fr MessageBoxen
'MB Types
const as integer MBType_OK=1
const as integer MBType_YESNO=2
const as integer MBType_CANCELRETRYIGNORE=3
const as integer MBType_OKCANCEL=4
const as integer MBType_RETRYCANCEL=5
const as integer MBType_YESNOCANCEL=6
'MB Button Returnwerte
const as integer MBButton_OK=1
const as integer MBButton_CANCEL=2
const as integer MBButton_RETRY=3
const as integer MBButton_IGNORE=4
const as integer MBButton_YES=5
const as integer MBButton_NO=6

'Men Statuskonstanten
const as integer MS_INACTIVE=0
const as integer MS_ACTIVE=1
const as integer MS_CHECKMARK=2
const as integer MS_SEPARATOR=4


'Farbkonstanten
const as uinteger black=&h000000,white=&hffffff

'globale GFX Variablen
dim shared as integer contrast,fontheight,CustomColors,SleepShade
'Farben
dim shared as uinteger TextColor,BackGroundColor,GadgetTextColor,GadgetColor,GadgetGlowColor,CursorColor
dim shared as uinteger MenuColor,MenuTextColor,MenuHiliteColor,MenuGhostedColor

'System Events
'Keyboard
dim shared as string  KEY
dim shared as integer ASCCODE
dim shared as integer EXTENDED
'Maus
dim shared as integer MOUSEX
dim shared as integer MOUSEY
dim shared as integer LMB
dim shared as integer MMB
dim shared as integer RMB
dim shared as integer WHEEL
dim shared as integer CLOSEBUTTON
'Vergleichs- und Steuerungswerte
dim shared as integer oldMOUSEX
dim shared as integer oldMOUSEY
dim shared as integer LMBpressed,MMBpressed,RMBpressed
dim shared as integer oldLMB
dim shared as integer oldMMB
dim shared as integer oldRMB
dim shared as integer oldWHEEL
dim shared as integer wheelvalue,oldwheelvalue

declare sub GadgetOn overload (gad as _Gadget ptr)
declare sub GadgetOn (gadblockstart as _Gadget ptr, gadblockend as _Gadget ptr)

declare sub GadgetSleep overload (gad as _Gadget ptr)
declare sub GadgetSleep (gadblockstart as _Gadget ptr, gadblockend as _Gadget ptr)

declare sub GadgetOff   overload (gad as _Gadget ptr)
declare sub GadgetOff (gadblockstart as _Gadget ptr, gadblockend as _Gadget ptr)

declare sub RestoreActivation overload (gad as _Gadget ptr)
declare sub RestoreActivation (gadblockstart as _Gadget ptr, gadblockend as _Gadget ptr)

declare sub GadOn    (gad as _Gadget ptr)
declare sub GadSleep (gad as _Gadget ptr)
declare sub GadOff   (gad as _Gadget ptr)

declare function GetSelect (gad as _Gadget ptr) as integer
declare sub SetSelect (gad as _Gadget ptr,Selection as integer)

declare sub DrawGadget(gad as _Gadget ptr)
declare function GadgetAction(gad as _Gadget ptr, action as integer) as integer
declare sub UpdateGadget(gad as _Gadget ptr)
declare sub SetCaption(gad as _Gadget ptr,Text as string)

declare function NewNode(nt as integer) as any ptr
declare sub KillNode(e as any ptr)

declare function UImport(s as string) as string
declare function UExport(s as string) as string

declare sub DelSubEvent(event as _EventHandle ptr)

'sGUI Includes
#include "sgui_systemevents.bas"
#include "phrases.bi"
#include "listobject.bas"
#include "sgui_gadgettype.bas"
#include "sgui_menutypes.bas"
#include "textobject.bas"
#include "togadgetbindings.bas"
#include "sgui_eventhandle.bas"
#include "sgui_misc.bas"
#include "sgui_drawing.bas"

end namespace

sGUI.CustomColors=0
sGUI.contrast=128'stellt tatschlich eine Art Kontrast-Variable dar
           'wer will,kann gerne mal mit rumspielen, es geht nichts kaputt :)
           'hab die 96 als angenehmsten empfunden
sGUI.SleepShade=255*.66
sGUI.CLOSEBUTTON=0
