' ======================================================================
' Connection to a chess engine under Windows
' ----------------------------------------------------------------------
' http://free-basic.ru/chess_fruit.html
' http://www.freebasic-portal.de/porticula/fbporticula1668.bas
' ======================================================================

#include once "windows.bi"

dim shared as HANDLE rHandle1, wHandle1

function Connect(aUciEngine as const string) as boolean
  dim as HANDLE rHandle2, wHandle2
  dim as STARTUPINFO vInfo
  dim as PROCESS_INFORMATION vProcessInfo
  dim as SECURITY_ATTRIBUTES vAttr
  vAttr.nLength = sizeof(SECURITY_ATTRIBUTES)
  vAttr.lpSecurityDescriptor = NULL
  vAttr.bInheritHandle = TRUE
  CreatePipe(@rHandle2, @wHandle1, @vAttr, 0)
  CreatePipe(@rHandle1, @wHandle2, @vAttr, 0)
  SetHandleInformation(wHandle1, HANDLE_FLAG_INHERIT, 0)
  SetHandleInformation(rHandle1, HANDLE_FLAG_INHERIT, 0)
  GetStartupInfo(@vInfo)
  with vInfo
    .dwFlags     = STARTF_USESTDHANDLES or STARTF_USESHOWWINDOW
    .wShowWindow = SW_HIDE
    .hStdOutput  = wHandle2
    .hStdError   = wHandle2
    .hStdInput   = rHandle2
  end with
  function = cbool(CreateProcess(0, aUciEngine, 0, 0, TRUE, 0, 0, 0, @vInfo, @vProcessInfo))
  CloseHandle(wHandle2)
  CloseHandle(rHandle2)
end function

sub SendCommand(aUciCommand as const string)
  dim as integer vWritten
  dim as string vBuffer = aUciCommand & Chr(10)
  WriteFile(wHandle1, StrPtr(vBuffer), Len(vBuffer), @vWritten, NULL)
end sub

function ReadEngineOutput as string
  const MAX_BUFFER_SIZE = 4096
  dim as integer vCount, vCount2
  dim as string vBuffer
  dim as string vResult = ""
  do
    sleep(10, 1)
    PeekNamedPipe(rHandle1, NULL, NULL, NULL, @vCount, NULL)
    if vCount > 0 then
      if vCount > MAX_BUFFER_SIZE then
        vCount = MAX_BUFFER_SIZE
      end if
      vBuffer = string(vCount, chr(0))
      ReadFile(rHandle1, strptr(vBuffer), vCount, @vCount2, NULL)
      vResult &= vBuffer
    else
      exit do
    end if
  loop
  return vResult
end function

sub Disconnect
  CloseHandle(wHandle1)
  CloseHandle(rHandle1)
end sub
